<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Document</title>

    <link
      href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.1/dist/css/bootstrap.min.css"
      rel="stylesheet"
      integrity="sha384-4bw+/aepP/YC94hEpVNVgiZdgIC5+VKNBQNGCHeKRQN+PtmoHDEXuppvnDJzQIu9"
      crossorigin="anonymous"
    />
    <script
      src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.1/dist/js/bootstrap.bundle.min.js"
      integrity="sha384-HwwvtgBNo3bZJJLYd8oVXjrBZt8cqVSpeBNS5n7C8IVInixGAoxmnlMuBnhbgrkm"
      crossorigin="anonymous"
    ></script>

    <link rel="preconnect" href="https://fonts.googleapis.com" />
    <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin />
    <link
      href="https://fonts.googleapis.com/css2?family=Happy+Monkey&display=swap"
      rel="stylesheet"
    />

    <style>
      .gradient-bg {
        background: conic-gradient(
          from -2deg at 52.89% 52.66%,
          #a5e3e7 85.24869740009308deg,
          #f0dac2 153.6356770992279deg,
          #f6e3cd 280.4881453514099deg,
          #9fe6ea 325.8042812347412deg
        );
        height: 70vw;
        display: flex;
        justify-content: center;
        align-items: center;
      }

      .content {
        width: 75%;
        height: 70%;
      }

      .right-content {
        background: #5fc3ca;
        display: flex;
        align-items: end;
        padding: 3rem;
        border-top-right-radius: 20px;
        border-bottom-right-radius: 20px;
      }

      .left-content {
        padding: 3rem;
        background: #fff;
        border-top-left-radius: 20px;
        border-bottom-left-radius: 20px;
      }

      .tittle {
        color: #000;
        font-family: Happy Monkey;
        font-size: 64px;
        font-style: normal;
        font-weight: 400;
        line-height: normal;
      }

      .des {
        color: #000;
        font-family: Happy Monkey;
        font-size: 16px;
        font-style: normal;
        font-weight: 400;
        line-height: 18px; /* 112.5% */

        margin-top: 1rem;
        margin-bottom: 2rem;
      }

      .des-span {
        color: #5fc3ca;
        font-family: Happy Monkey;
        font-size: 16px;
        font-style: normal;
        font-weight: 400;
        line-height: 18px;
        text-decoration-line: underline;
      }

      button {
        border-radius: 10px;
        background: #5fc3ca;
        padding: 12px 80px 12px 80px;
        border: 0px;
        margin-top: 3rem;
        margin-bottom: 2rem;

        color: #fff;
        text-align: center;
        font-family: Happy Monkey;
        font-size: 20px;
        font-style: normal;
        font-weight: 400;
        line-height: normal;
      }
    </style>
  </head>
  <body>
    <div class="container-fluid gradient-bg">
      <div class="row content">
        <div class="col-md-7 left-content">
          <div class="tittle">Contact Us</div>
          <div class="des">
            We’re here to help! Send us your query via the form below or send us
            an email at <span class="des-span">helpdesk@gstudio.com</span> for
            any issue you’re facing
          </div>

          <form action="" id="submit-form">
            <div class="form-group">
              <input
                id="input-name"
                type="text"
                class="form-control"
                placeholder="Name"
              />
            </div>

            <div
              class="form-group"
              style="margin-top: 1rem; margin-bottom: 1rem;"
            >
              <input
                id="input-email"
                type="text"
                class="form-control"
                placeholder="Email Address"
              />
            </div>

            <div class="form-group">
              <textarea
                id="text-area-message"
                class="form-control"
                placeholder="Type your message here"
              ></textarea>
            </div>

            <div style="text-align: center;">
              <button type="submit">Submit</button>
            </div>
          </form>
        </div>
        <div class="col-md-5 right-content">
          <img
            src="images/Tech-computer.png"
            style="width: 100%; padding-top: 100%; background-size: cover;"
          />
        </div>
      </div>
    </div>
  </body>

  <script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_CREATED = 201;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL_CONTACTS =
      "https://62458c222cfed18817229118.mockapi.io/contacts";
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    var submitForm = document.getElementById("submit-form");
    submitForm.addEventListener("submit", (e) => {
      // Sử dụng preventDefault để loại bỏ hành động submit mặc định của form
      e.preventDefault();
      // Bước 0: Khởi tạo đối tượng thu thập
      var vObject = {
        name: "",
        email: "",
        mess: "",
      };
      // Bước 1: thu thập dữ liệu
      getDataFromInput(vObject);
      // Bước 2: Kiểm tra dữ liệu thu thập
      var vCheck = validateData(vObject);
      // Bước 3: gọi API xử lý
      if (vCheck) {
        // create a request
        var vXmlHttpCreateContact = new XMLHttpRequest();
        processAPI(vXmlHttpCreateContact, vObject);
        vXmlHttpCreateContact.onreadystatechange = function () {
          if (
            this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
            this.status == gREQUEST_STATUS_CREATED
          ) {
            var vSubmitRespond = vXmlHttpCreateContact.responseText;
            //B4: hiển thị dữ liệu
            hienThiDuLieu(vSubmitRespond);
          }
        };
      }
    });
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm thu thập dữ liệu
    function getDataFromInput(paramObject) {
      "use strict";
      var vNameInput = document.getElementById("input-name");
      var vEmailInput = document.getElementById("input-email");
      var vMessTextarea = document.getElementById("text-area-message");

      paramObject.name = vNameInput.value;
      paramObject.email = vEmailInput.value;
      paramObject.mess = vMessTextarea.value;
    }

    // Hàm kiểm tra dữ liệu thu thập
    // Input là đối tượng dữ liệu cần kiểm tra
    // Output là kết quả true / false
    function validateData(paramObject) {
      "use strict";
      var vName = paramObject.name.trim(); // Chuẩn hóa dữ liệu
      var vEmail = paramObject.email.trim();
      var vMess = paramObject.mess.trim();

      if (vName == "") {
        alert("Name is empty!");
        return false;
      }

      if (vEmail == "") {
        alert("Email is empty!");
        return false;
      }
      if (validateEmail(vEmail) == false) {
        alert("Email is invalid!");
        return false;
      }

      return true;
    }

    // Hàm kiểm tra email
    // Input là email cần kiểm tra
    // Output là true / false
    function validateEmail(mail) {
      if (/^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test(mail)) {
        return true;
      }
      return false;
    }

    // Hàm xử lý ajax API create contact
    // Input là đối tượng Request và đối tượng dữ liệu
    function processAPI(paramRequest, paramObject) {
      "use strict";
      var vData = JSON.stringify({ paramObject });

      paramRequest.open("POST", gBASE_URL_CONTACTS, true);
      paramRequest.send(vData);
    }

    //hàm hiển thị dữ liệu
    function hienThiDuLieu(paramRespond) {
      console.log(paramRespond);
    }
  </script>
</html>
